VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Scomposizione in Fattori Primi"
   ClientHeight    =   2475
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9015
   LinkTopic       =   "Form1"
   ScaleHeight     =   2475
   ScaleWidth      =   9015
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox TxtRisultato 
      Height          =   495
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   1320
      Width           =   8535
   End
   Begin VB.TextBox TxtDato 
      Height          =   285
      Left            =   4560
      TabIndex        =   0
      Top             =   440
      Width           =   3255
   End
   Begin VB.Label LblRisultato 
      Caption         =   "Risultato:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   360
      TabIndex        =   4
      Top             =   1080
      Width           =   855
   End
   Begin VB.Label LblNumeroDaScomporre 
      Caption         =   "Scrivi il Numero da Scomporre in Fattori Primi:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   360
      TabIndex        =   3
      Top             =   480
      Width           =   4095
   End
   Begin VB.Label LblPrimiAcquisiti 
      Caption         =   " ( Nota: Numeri Primi acquisiti in memoria:            - Numero Primo pi elevato in memoria:           )"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   2160
      Width           =   8535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Ricerca di Numeri Primi e Scomposizione in Fattori Primi di un Numero dato
' by Claudio Panzarani (Soluzioni Informatiche di C.P. - 00189 Roma, via Bruno Bruni, 94)
' E-mail: panzarani@solinformatiche.it
' Freeware. Sono graditi consigli, miglioramenti, critiche, etc.

' Questo programmino calcola inizialmente un certo numero di fattori primi da utilizzare per i calcoli successivi,
' e li mette in un vettore denominato "Primi". In questa stesura  dimensionato di 5000, ma in funzione della
' velocit del processore  possibile modificarlo (il valore incide sul tempo necessario per eseguire il Form Load:
' un Athlon 1800 impiega 24 secondi a calcolare i primi 20.000 numeri primi).
' La veste grafica  spartana, come capita ai programmi sperimentali: niente avvisi nella fase iniziale di attesa, etc.
' Una buona modifica del programma sarebbe quella di suddividerlo in due programmi separati:
' uno che calcola preventivamente i numeri primi e li mette su un vettore memorizzato su disco (un po' per giorno
' si calcolerebbero sempre pi numeri primi che resterebbero acquisiti senza doverli ricalcolare ogni volta);
' la seconda parte calcolerebbe i fattori primi per un numero dato, utilizzando il vettore su disco
' anzich quello in memoria come fa questa stesura. Chi ha voglia di divertirsi...


Dim Primi(1 To 5000) As Long        'E' il vettore che contiene i numeri primi calcolati inizialmente (vedi Form Load)
Dim PrimiTrovati As Integer         'Contiene il numero dei numeri primi trovati
Dim Dato As Currency                'Contiene il numero inserito dall'Utente, del quale occorre trovare i fattori primi
Dim i As Integer                    'Variabile di lavoro
Dim j As Integer                    'Variabile di lavoro
Dim NumeroEsaminato As Long         'Contiene il numero che di volta in volta viene esaminato per verificare se  primo (usato solo nel Form Load)
Dim Indice As Integer               'Indica quante volte un numero primo  contenuto nel numero dato (Es.: 26=2*13   Il numero primo 13  contenuto due volte nel numero dato 26. Il 2  quello che ho chiamato indice)

Private Sub Form_Load()
    PrimiTrovati = 1                                'Il primo Numero Primo lo fornisco io
    Primi(1) = 2                                    'ed  il numero 2
    For NumeroEsaminato = 3 To 100000000 Step 2     'cos posso iniziare a calcolare dal 3 in poi. Esamino quindi i soli numeri dispari (infatti i numeri primi, a parte il 2, non possono essere pari perch sarebbero divisibili per due)
        For j = 2 To PrimiTrovati - 1                                   'Utilizzo quindi ciascun numero primo gi trovato (escluso il 2, tanto lavoro solo sui numeri dispari)
            If NumeroEsaminato Mod Primi(j) = 0 Then GoTo Abbandona     'e se il numero in esame  perfettamente divisibile per uno dei primi gi trovati lo abbandono perch non  primo
        Next j
        PrimiTrovati = PrimiTrovati + 1                                 'Se invece non  divisibile per nessuno dei Primi gi trovati
        Primi(PrimiTrovati) = NumeroEsaminato                           'vuol dire che  primo anche lui e lo aggiungo alla lista
        If PrimiTrovati = 5000 Then                                     'e se  il 5000.mo il calcolo iniziale  finito. Per aumentare questo numero occorre variare sia questo parametro che quello corrispondente nella "Dim Primi(1 to 5000)" iniziale
            Exit For                                                    'nonch l'altro nel For della Sub CalcolaFattori
        End If
Abbandona:
    Next NumeroEsaminato
    LblPrimiAcquisiti = " ( Nota: Numeri Primi acquisiti in memoria: " & Format(PrimiTrovati, "#,###") & " - Numero Primo pi elevato in memoria: " & Format(NumeroEsaminato, "#,###") & " )"
End Sub

Private Sub CalcolaFattori()
    For i = 1 To 5000                       'Il contatore i punta successivamente ai numeri primi gi trovati.
        Indice = 0
Ripeti:
        If Dato Mod Primi(i) = 0 Then       'Se il numero dato  perfettamente divisibile per il numero primo che si sta considerando
            Dato = Dato / Primi(i)          'lo divide per quel numero primo (che  un suo fattore). (Nota: il numero dato viene ogni volta modificato cos da poter effettuare sempre la stessa serie di calcoli.)
            Indice = Indice + 1             'Quindi calcola quante volte quel fattore  contenuto nel numero dato,
            GoTo Ripeti                     'e ripete l'operazione per verificare se il numero primo considerato  contenuto altre volte nel numero dato.
        End If
        If Indice > 0 Then                  'Se l'indice calcolato  > 0 vuol dire che il loop precedente ha dato esito positivo, e quindi
            If Len(TxtRisultato) > 0 Then TxtRisultato = TxtRisultato & " * "       'aggiorna in conseguenza il TxtRisultato
            TxtRisultato = TxtRisultato & Primi(i)
            If Indice > 1 Then TxtRisultato = TxtRisultato & "^" & Indice
        End If
        If Dato = 1 Then Exit For           'Quando il numero dato si riduce a 1, il calcolo  terminato con esattezza.
    Next i                                  'Se invece il numero dato ha un residuo, vuol dire che i numeri primi a disposizione
                                            'non sono stati sufficienti per effettuare un calcolo completo, e quindi tale differenza viene
                                            'inserita solo per far s che moltiplicando quanto indicato nel TxtRisultato si ottenga il numero dato.
    If Dato > 1 Then TxtRisultato = TxtRisultato & " * " & Dato
    TxtTxtRisultato = TxtRisultato
    TxtDato.SelStart = 0
    TxtDato.SelLength = Len(TxtDato)
    TxtDato.SetFocus
End Sub

Private Sub TxtDato_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyReturn Then          'Il tasto invio fa partire il calcolo
        KeyAscii = 0                        'Questa istruzione serve ad eliminare il Beep che seguirebbe
        TxtRisultato = ""                   'Pulisce eventuali risultati di calcoli precedenti
        If IsNumeric(TxtDato) Then          'Verifica che nel numero dato non ci siano alfabetici o altre porcherie
            Dato = CCur(TxtDato)
            CalcolaFattori
        End If
    Else
        TxtDato.SetFocus                    'Se il tasto premuto non  l'Invio, prosegue l'input
    End If
End Sub
